#ifndef IMCSONGDATATYPES_H
#define IMCSONGDATATYPES_H

struct TImcSongEnvelope {
  int minVal;
  int maxVal;
  int speed;
  unsigned char phase;
  unsigned char keep;
  unsigned char sustain;
  bool resetOnNewNote;
  unsigned char resetOnPatternMask;
};

struct TImcSongEnvelopeCounter {
  unsigned char envId;
  unsigned char channel;
  int val;
};

#define IMCSONGOSCTYPE_SINE 0
#define IMCSONGOSCTYPE_SAW 1
#define IMCSONGOSCTYPE_SQUARE 2
#define IMCSONGOSCTYPE_NOISE 3

struct TImcSongOscillator {
  unsigned char transOctave;
  unsigned char transFine;
  unsigned char type;
  unsigned char channel;
  unsigned char fmTargetOscId;
  unsigned char vol;
  unsigned char volEnvCounterId;
  unsigned char transEnvCounterId;
};

#define IMCSONGEFFECTTYPE_DELAY 0
#define IMCSONGEFFECTTYPE_FLANGE 1
#define IMCSONGEFFECTTYPE_LOWPASS 2
#define IMCSONGEFFECTTYPE_HIGHPASS 3
#define IMCSONGEFFECTTYPE_RESONANCE 4
#define IMCSONGEFFECTTYPE_OVERDRIVE 5

struct TImcSongEffect {
  int v1;
  int v2;
  int histSize;
  unsigned char channel;
  unsigned char type;
  unsigned char envCounterId1;
  unsigned char envCounterId2;
};

#endif